import java.awt.*;
import java.util.*; // LinkedList && ListIterator


public class Buble extends Sprite {
static Color colors[]={Color.RED,Color.YELLOW,Color.BLUE,Color.GREEN,Color.WHITE,Color.MAGENTA,Color.CYAN};
static double RADIUS = 20.0;
static double LOAD_SPEED = 6.0;
static double SHOT_SPEED = 20.0;
static double LOAD_ANGLE = 0.0;
static double INITIAL_Y = Display.HEIGHT - Buble.RADIUS;
double speed;
int color;


	public Buble(){
		super(0.0, INITIAL_Y, LOAD_ANGLE);
		speed = LOAD_SPEED;
		color = (int) (Math.random()*colors.length) % colors.length;
	}


	public Buble(double x, double y, double angle) {
		super(x, y, angle);
		speed = LOAD_SPEED;
		color = (int) (Math.random()*colors.length) % colors.length;
	}


	public void draw(Graphics g) {
		g.setColor(colors[color]);
		g.fillOval(	(int)(location.getX()-RADIUS),(int)(location.getY()-RADIUS),
															(int)RADIUS*2,(int)RADIUS*2);
	}


	public void run(LinkedList collisionObjects) {
		locationAfterMove.setXY(location.getX()+speed*Math.cos(dirAngle),
										location.getY()-speed*Math.sin(dirAngle));
		ListIterator iterator = collisionObjects.listIterator();
		while( iterator.hasNext() ){
			Sprite obj = (Sprite) iterator.next();
			if(obj.checkCollision(this)){
//				System.out.println("Stopping buble id "+this.hashCode());
				Bubles.moving.remove(this);
				speed = 0.0;
				if( locationAfterMove.getY() > Court.COURT_END-RADIUS ){
					Bubles.endGame();
				}
			}
		}
		location.setXY(locationAfterMove.getX(),locationAfterMove.getY());
	}

	
	public boolean checkCollision(Buble buble){
		if(buble!=this && location.distance(buble.locationAfterMove) < RADIUS*2){
			Vector2D uv = buble.locationAfterMove.substract(location).unitVector();
			buble.locationAfterMove = uv.multiply(RADIUS*2).add(location);
			if(buble.speed == SHOT_SPEED){ // after they have been shot, collision stops the buble
				if(color==buble.color){
					Bubles.sprites.remove(this);
					Bubles.sprites.remove(buble);
				}
				return true;
			}
		}
		return false;
	}

}
