import java.awt.event.*;
import javax.swing.*;
import java.util.*; // LinkedList and ListIterator


public class Bubles implements Runnable, ActionListener {
static LinkedList sprites;	// all drawn objects are stored here
static LinkedList clip;	// bubles in the clip - loaded to be shot
static LinkedList moving;	// once bubles are shot and stop they are removed
static Gun gun;
static JFrame frame;
static Display pane;
static int STOP_BYBUBLE = 1;
static int STOP_NEWGAME = 2;
static int stop = STOP_NEWGAME;	// reason for stopping the thread
JMenuItem gameNew;
JMenuItem gameQuit;
JMenuBar menuBar;
JMenu gameMenu;


	void refresh(){
		try{
			ListIterator iterator = moving.listIterator();
			while(iterator.hasNext()){
				Sprite obj = (Sprite) iterator.next();
				obj.run(sprites);
			}
		} catch(ConcurrentModificationException e){
			System.out.print(".");
		}
		pane.repaint(); // inner classes can access parent class variables
		try{ Thread.sleep(20); } // 30ms = up to 30 fps :)
		catch( InterruptedException ex ){}
	}


	public void run(){ // run this as a separate thread
		do{
			clip = new LinkedList();
			gun = new Gun();
			sprites = new LinkedList();
			sprites.add(gun);
			sprites.add(new Court());
			moving = new LinkedList();
			moving.add(gun);
			frame.addKeyListener(gun);
			for(int i = 0; i < 4; i++){			// we do this so balls can be added to a clip
				Buble b = new Buble();				// while screen refreshes
				clip.addFirst(b);
				sprites.add(b);
				moving.add(b);
				for(int j =0; j < 20; j++){
					refresh();						// refresh objects
				}
			}
			stop = 0;
			while(stop==0){ // when game ends this flag is set, user has a choice to start newGame
				refresh();
			}
			frame.removeKeyListener(gun);
			if(stop == STOP_BYBUBLE){ // game ended - ask if want to play again?
				EndGameDialog md = new EndGameDialog(frame);
				md.show();
				if(md.getChoice()){
					stop = STOP_NEWGAME;
				}
			}
		}while(stop == STOP_NEWGAME); // game ended but new game was selected
	}


	public static void endGame(){
		stop = STOP_BYBUBLE; // this should signal WorkThread to end depending on newGame value
	}


	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		if( cmd.equalsIgnoreCase("New Game") ){
			if(stop != 0){					// if thread is already stopped
				new Thread(this).start();	// restart the thread
			} else {						// otherwise
				stop = STOP_NEWGAME;		// new game was pressed in the menu while game is running
			}
		} else if( cmd.equalsIgnoreCase("Quit") ){
			System.exit(0);
		}
	}


	void start(){
		gameNew = new JMenuItem("New Game");
		gameNew.addActionListener(this);
		gameQuit = new JMenuItem("Quit");
		gameQuit.addActionListener(this);

		gameMenu = new JMenu("File");
		gameMenu.setMnemonic(KeyEvent.VK_F);
		gameMenu.add(gameNew);
		gameMenu.addSeparator();
		gameMenu.add(gameQuit);
	
		menuBar = new JMenuBar();
		menuBar.add(gameMenu);
		pane = new Display();

		frame = new JFrame("Bubles");
		frame.setJMenuBar(menuBar);
		frame.getContentPane().add(pane);
		frame.setSize(Display.WIDTH+6,Display.HEIGHT+48);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setLocationRelativeTo(null);	// center it

//		new Thread(this).start();			// get things ready to be shown before showing it
		frame.show();
	}


	public static void main(String[] args) {
		Bubles main = new Bubles();
		main.start();
	}
}
