import java.awt.*;				// Color, Graphics
import java.util.LinkedList;

public class Court extends Sprite {
static int COURT_END = Display.HEIGHT - 60;
	public void run(LinkedList collisionObjects){}

	Court(){
		super(Display.D_WIDTH,Display.D_HEIGHT,0.0);
	}


	public void draw(Graphics g) {
		g.setColor(Color.ORANGE);
		g.drawRect(1,1,Display.WIDTH-2,Display.HEIGHT-2);
		g.drawLine(0, COURT_END, Display.WIDTH, COURT_END);
	}


	double scale(double p1, double p2, double line){ // scale the vector so it bounces off the wall
		double x1= Math.abs(p1-p2);
		double x2 = Math.abs(p1-line);
		return (x2-Buble.RADIUS)/x1;
	}


	public boolean checkCollision(Buble buble) {
		double x = buble.locationAfterMove.getX();	// you need to know something about the object
		double y = buble.locationAfterMove.getY();	// to bounce it properly
		if(y > Display.D_HEIGHT-Gun.GUN_HEIGHT){	// do not bounce off the wall if was not shot
			return false;
		} 
		if(x+Buble.RADIUS>Display.D_WIDTH){
			double s = scale(buble.location.getX(),x,Display.D_WIDTH);
//			System.out.println("location.y="+buble.location.getY()+" locationAfter.y="+y+" scale="+s);
			Vector2D diff = buble.locationAfterMove.substract(buble.location).multiply(s);
			buble.locationAfterMove = buble.location.add(diff);
			buble.dirAngle = Math.PI-buble.dirAngle; // reflection off the side wall
		} else if(x-Buble.RADIUS<0.0){
			double s = scale(buble.location.getX(),x,0.0);
//			System.out.println("location.y="+buble.location.getY()+" locationAfter.y="+y+" scale="+s);
			Vector2D diff = buble.locationAfterMove.substract(buble.location).multiply(s);
			buble.locationAfterMove = buble.location.add(diff);
			buble.dirAngle = Math.PI-buble.dirAngle; // reflection off the side wall
		} else if(y-Buble.RADIUS<0.0){
			double s = scale(buble.location.getY(),y,0.0);
//			System.out.println("location.y="+buble.location.getY()+" locationAfter.y="+y+" scale="+s);
			Vector2D diff = buble.locationAfterMove.substract(buble.location).multiply(s);
			buble.locationAfterMove = buble.location.add(diff);
			return true; // buble stops
		}
		return false; // buble will keep moving
	}
	
}
