import java.awt.*;			// Color, Graphics
import java.awt.event.*;	// KeyEvent and KeyListener
import java.util.LinkedList;

public class Gun extends Sprite implements KeyListener {
static double GUN_HEIGHT = Display.D_HEIGHT - Court.COURT_END;
static double GUN_WIDTH = GUN_HEIGHT;
static double MIN_ANGLE = 0.5;
static double MAX_ANGLE = Math.PI-MIN_ANGLE;
static double CENTER_ANGLE = Math.PI/2;
double turnAngle;

	public Gun() {
		super(Display.D_WIDTH/2.0, Display.D_HEIGHT, CENTER_ANGLE);
		turnAngle = 0.0;
	}


	public void draw(Graphics g) {
		int x = (int)location.getX();
		int y = (int) (location.getY() - Buble.RADIUS);
		int diam = (int) Buble.RADIUS*2+2;
		g.setColor(Color.CYAN);
		g.drawLine(x, y, x+(int)(GUN_HEIGHT*Math.cos(dirAngle)),
				y-(int)( (GUN_HEIGHT-Buble.RADIUS)*Math.sin(dirAngle)) );
		g.drawOval((int)(x-Buble.RADIUS-1.0), (int)(y-Buble.RADIUS-1.0), diam, diam);
	}


	public void run(LinkedList collisionObjects) {
		dirAngle +=turnAngle;
		if(dirAngle<MIN_ANGLE){
			dirAngle =MIN_ANGLE;
		}
		if(dirAngle>MAX_ANGLE){
			dirAngle = MAX_ANGLE;
		}
	}


	public boolean checkCollision(Buble buble) {
		double x = buble.locationAfterMove.getX();
		double y = buble.locationAfterMove.getY();
		if(y >= Buble.INITIAL_Y && x > location.getX()-GUN_WIDTH-Buble.RADIUS){ // 
				buble.locationAfterMove = new Vector2D(location.getX()-GUN_WIDTH-Buble.RADIUS,Buble.INITIAL_Y); // 
				buble.speed=0.0;
		}
		return false;
	}


	public void keyPressed(KeyEvent event) {
		if( event.getKeyCode() == KeyEvent.VK_LEFT ){ // turn gun left
			turnAngle = (MAX_ANGLE - MIN_ANGLE)/60;
		}
		if( event.getKeyCode() == KeyEvent.VK_RIGHT ){ // turn gun right
			turnAngle = (MIN_ANGLE-MAX_ANGLE)/60.0;
		}
		if( event.getKeyCode() == KeyEvent.VK_UP ){ // shoot VK_SPACE ?
//			System.out.println("Shooting");
			Buble newBuble = new Buble();
			Bubles.sprites.add(newBuble); // display list
			Bubles.moving.add(newBuble);
			Bubles.clip.addFirst(newBuble); // new buble gets loaded
			Buble shot = (Buble) Bubles.clip.removeLast();
			shot.dirAngle = dirAngle;
			shot.speed = Buble.SHOT_SPEED;
			shot.location.setXY(location.getX(),location.getY()-Buble.RADIUS);
		}
	}


	public void keyReleased(KeyEvent event) {
		int key = event.getKeyCode();
		if((key==KeyEvent.VK_RIGHT && turnAngle < 0.0) || (key==KeyEvent.VK_LEFT && turnAngle > 0.0) ){
			turnAngle = 0.0;
		}
	}

	public void keyTyped(KeyEvent event) {} // stub for interface KeyListener

}
