class Vector2D {
public double x;
public double y;


	public double getX(){
		return x;
	}
	public double getY(){
		return y;
	}
	public void setX(double fx){
		x = fx;
	}
	public void setY(double fy){
		y = fy;
	}
	public void setXY(double fx, double fy){
		x = fx;
		y = fy;
	}

	public Vector2D(double fx, double fy){
		x = fx;
		y = fy;
	}
	public String toString(){
		return "("+x+","+y+")";
	}


	public Vector2D multiply(double d){
		return new Vector2D(x*d,y*d);
	}
	public double cross(Vector2D v){
		return x*v.y - y*v.x;
	}


	public Vector2D add(Vector2D v) {
		return new Vector2D(x+v.x,y+v.y);
	}
	public Vector2D substract( Vector2D v){
		return new Vector2D(x-v.x,y-v.y);
	}


	public double distance( Vector2D v){
		return substract(v).scalarValue();
	}
	public double scalarValue(){
		return Math.sqrt(x*x+y*y);
	}

	public Vector2D unitVector(){
		double len = Math.sqrt(x*x+y*y);
		return new Vector2D(x/len,y/len);
	}

}
